#include <uhub.h>

struct adc_message* g_msg;

QC_TEST(test_message_refc_1, {
	g_msg = adc_msg_create("IMSG Hello\\sWorld!");
	return g_msg != NULL;
});

QC_TEST(test_message_refc_2, {
	return g_msg->references == 0; // 0
});

QC_TEST(test_message_refc_3, {
	adc_msg_incref(g_msg);
	return g_msg->references == 1; // 1
});

QC_TEST(test_message_refc_4, {
	adc_msg_incref(g_msg);
	return g_msg->references == 2; // 2
});

QC_TEST(test_message_refc_5, {
	adc_msg_free(g_msg);
	return g_msg->references == 1; // 1
});

QC_TEST(test_message_refc_6, {
	adc_msg_free(g_msg);
	return g_msg->references == 0; // 0
});

QC_TEST(test_message_refc_7, {
	adc_msg_free(g_msg);
	return g_msg->references == 0; // gone.
});

